package cn.rankin.apiweb.service.download;

import cn.rankin.data.api.user.dto.DownloadInfoDTO;
import cn.rankin.data.api.user.entity.DownloadInfo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "${service.user.name}")
public interface DownloadInfoClient {

    @RequestMapping(value = "/download", method = RequestMethod.POST)
    DownloadInfo add(@RequestBody DownloadInfoDTO dto);

    @RequestMapping(value = "/download/list", method = RequestMethod.GET)
    List<DownloadInfo> findByUserId(@RequestParam("uid") String uid , @RequestParam("mac") String mac);

    @RequestMapping(value = "/download", method = RequestMethod.GET)
    DownloadInfo findByLessonUserId(@RequestParam("uid") String uid, @RequestParam("lessonId") String lessonId, @RequestParam("mac") String mac);

    @RequestMapping(value = "/download/delete", method = RequestMethod.DELETE)
    DownloadInfo deleteByLessonUserId(@RequestParam("uid") String uid, @RequestParam("lessonId") String lessonId, @RequestParam("mac") String mac);

    @RequestMapping(value = "/download/update/resource", method = RequestMethod.PUT)
    DownloadInfo updateByLessonUserId(@RequestParam("uid") String uid, @RequestParam("lessonId") String lessonId, @RequestParam("mac") String mac);

    @RequestMapping(value = "/download/update", method = RequestMethod.PUT)
    DownloadInfo update(@RequestBody DownloadInfo downloadInfo);

    @RequestMapping(value = "/download/fail", method = RequestMethod.PUT)
    boolean downloadFail(@RequestParam("uid") String uid, @RequestParam("mac") String mac);

    @RequestMapping(value = "/download/status", method = RequestMethod.GET)
    DownloadInfo findDownloadStatus(@RequestParam("uid")String uid, @RequestParam("lessonId") String lessonId, @RequestParam("mac") String mac);
}
