package cn.rankin.apiweb.service.download;

import cn.rankin.data.api.user.dto.DownloadInfoDTO;
import cn.rankin.data.api.user.entity.DownloadInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class DownloadInfoService {

    @Autowired
    private DownloadInfoClient downloadInfoClient;

    public DownloadInfo add(DownloadInfoDTO dto) {
        return downloadInfoClient.add(dto);
    }


    public List<DownloadInfo> findByUserId(String uid , String mac) {
        return downloadInfoClient.findByUserId(uid, mac);
    }

    public DownloadInfo findByLessonUserId(String uid,String lessonId, String mac) {
        return downloadInfoClient.findByLessonUserId(uid,lessonId,mac);
    }

    public DownloadInfo deleteByLessonUserId(String uid, String lessonId, String mac) {
        return downloadInfoClient.deleteByLessonUserId(uid,lessonId,mac);
    }

    public DownloadInfo updateByLessonUserId(String uid, String lessonId, String mac) {
        return downloadInfoClient.updateByLessonUserId(uid,lessonId,mac);
    }

    public synchronized DownloadInfo update(DownloadInfo downloadInfo) {
        return downloadInfoClient.update(downloadInfo);
    }

    public boolean downloadFail(String uid, String mac) {
        return downloadInfoClient.downloadFail(uid, mac);
    }

    public DownloadInfo findDownloadStatus(String uid, String lessonId, String mac) {
        return downloadInfoClient.findDownloadStatus(uid,lessonId,mac);
    }
}
