package cn.rankin.apiweb.service.tag;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.vo.ItemVo;
import cn.rankin.data.api.app.vo.TagTypeVo;
import cn.rankin.data.api.app.vo.TagVo;
import cn.rankin.data.api.product.entity.TagGroup;
import cn.rankin.data.api.product.entity.TagType;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "${service.product.name}")
public interface TagClient {

    @RequestMapping(value = "/app/tagGroup/code/{code}", method = RequestMethod.GET)
    APIResult<TagGroup> findTagGroupByCode(@PathVariable("code") String code, @RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/app/tagType/code/{code}", method = RequestMethod.GET)
    APIResult<List<TagVo>> findTagByTypeCode(@PathVariable("code") String code, @RequestParam("merchantId") String merchantId);

    @RequestMapping(value = "/app/tag/item/{tagId}", method = RequestMethod.GET)
    APIResult<Page<ItemVo>> findPageByTagId(@PathVariable("tagId") String tagId, @RequestParam("merchantId") String merchantId,
                                            @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer pageSize);

    @RequestMapping(value = "/tagType/app/code/{code}", method = RequestMethod.GET)
    TagTypeVo findTagTypeByCode(@PathVariable("code") String code);

    @RequestMapping(value = "/tagType/app/tag/code/{code}", method = RequestMethod.GET)
    List<TagVo> findTagByTypeCodeMerchant(@PathVariable("code") String code, @RequestParam("merchantId") String merchantId);
}
