package cn.rankin.data.api.user.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.EventTypeEnum;
import cn.rankin.common.utils.enums.PlatformTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


@Data
@ToString
@Entity
@Table(name = "u_download_info")
@DynamicInsert
@DynamicUpdate
public class DownloadInfo implements Serializable {
    @Id
    @Column(name="id")
    private String id;

    @Column(name="user_id")
    private String userId;

    @Column(name="merchant_id")
    private String merchantId;

    @Column(name="lesson_id")
    private String lessonId;

    @Column(name="lesson_name")
    private String lessonName;

    @Column(name="course_id")
    private String courseId;

    @Column(name="course_name")
    private String courseName;

    @Column(name="download_status", nullable = false)
    private int downloadStatus;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="event_type", nullable = false)
    private EventTypeEnum eventType;

    @Column(name="device_type")
    private String deviceType;

    @Column(name="mac")
    private String mac;

    @Column(name="ip")
    private String ip;

    @Column(name="device_version")
    private String deviceVersion;

    //资源总数
    @Column(name="res_total")
    private int resTotal;

    //已转码资源数
    @Column(name="res_size")
    private int resSize;

    @Column(name="data")
    private String data;

    @Column(name="need_update")
    private Integer needUpdate;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="platform_type")
    private PlatformTypeEnum platformType;

    @Enumerated(EnumType.ORDINAL)
    @Column(name="status")
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

}



