package cn.rankin.data.api.user.entity;

import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;


@Data
@ToString
@Entity
@Table(name = "u_user_device")
@DynamicInsert
@DynamicUpdate
public class UserDevice implements Serializable {
    @Id
    @Column(name="id")
    private String id;

    @Column(name="user_id")
    private String userId;

    @Column(name="device_code")
    private String deviceCode;

    //设备型号
    @Column(name="device_model")
    private String deviceModel;

    //设备厂商
    @Column(name="device_mfrs")
    private String deviceMfrs;

    //设备名称
    @Column(name="device_name")
    private String deviceName;

    //设备类型
    @Column(name="device_type")
    private String deviceType;

    @Column(name="num")
    private int num;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

}



