package cn.rankin.productservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.dto.ItemSearchDTO;
import cn.rankin.data.api.app.vo.ItemVo;
import cn.rankin.productservice.service.app.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "")
public class ItemController {

    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/app/item/ids", method = RequestMethod.POST)
    public APIResult<List<ItemVo>> findByIds(@RequestBody List<String> productIdList, @RequestParam("merchantId") String merchantId) {
        List<ItemVo> itemVoList = itemService.findByPids(merchantId, productIdList);
        return APIResult.ok(itemVoList);
    }

    @RequestMapping(value = "/app/item/ids/page", method = RequestMethod.POST)
    public APIResult<Page<ItemVo>> findPage(@RequestBody ItemSearchDTO itemSearchDTO) {
        String merchantId = itemSearchDTO.getMerchantId();
        String tagId = itemSearchDTO.getTagId();
        List<String> productIdList = itemSearchDTO.getProductIdList();
        Integer pageNo = itemSearchDTO.getPageNo();
        Integer pageSize = itemSearchDTO.getPageSize();
        return itemService.findPageByTagIdAndPids(merchantId, tagId, productIdList, pageNo, pageSize);
    }

    @RequestMapping(value = "/item/pids", method = RequestMethod.POST)
    public List<ItemVo> findItemByPids(@RequestBody List<String> productIdList, @RequestParam("merchantId") String merchantId) {
        return itemService.findByPids(merchantId,productIdList);
    }

    @RequestMapping(value = "/item/pid", method = RequestMethod.POST)
    public ItemVo findItemByPid(@RequestParam("pid") String pid, @RequestParam("merchantId") String merchantId) {
        return itemService.findByPid(merchantId,pid);
    }

}
