package cn.rankin.productservice.controller.app;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.vo.ItemVo;
import cn.rankin.data.api.product.entity.Tag;
import cn.rankin.data.api.product.entity.TagGroup;
import cn.rankin.productservice.service.TagService;
import cn.rankin.productservice.service.app.ItemService;
import cn.rankin.productservice.service.TagGroupService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/app")
public class AppTagController {

    @Autowired
    private TagGroupService tagGroupService;

    @Autowired
    private ItemService itemService;

    @Autowired
    private TagService tagService;

    @RequestMapping(value = "/tagGroup/code/{code}", method = RequestMethod.GET)
    public APIResult<TagGroup> findTagGroupByCode(@PathVariable("code") String code, @RequestParam("merchantId") String merchantId) {
        return tagGroupService.findTagGroupByCode(code, merchantId);
    }

    @RequestMapping(value = "/tag/item/{tagId}", method = RequestMethod.GET)
    public APIResult<Page<ItemVo>> findItemByTagId(@PathVariable("tagId") String tagId, @RequestParam("merchantId") String merchantId,
                                                   @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer pageSize) {
        return itemService.findPageByTagId(tagId, merchantId, pageNo, pageSize);
    }

    @RequestMapping(value = "/tagType/code/{typeCode}", method = RequestMethod.GET)
    public APIResult<List<Tag>> getTagsByTypeCode(@PathVariable("typeCode") String typeCode, @RequestParam("merchantId") String merchantId) {
        //开始组装数据
        //标签列表数据
        List<Tag> tagList = tagService.findByTypeCode(typeCode,merchantId);

        //标签下   课程数据
        tagList.forEach(tag -> {
            String tagId = tag.getId();
            List<ItemVo> itemVoList = itemService.findPageByTagId(tagId, merchantId);
            tag.setRecs(itemVoList);
        });
        return APIResult.ok(tagList);
    }

    @RequestMapping(value = "/tag/{tagId}", method = RequestMethod.GET)
    public Tag getTag(@PathVariable("tagId") String tagId) {
        return tagService.find(tagId);
    }
}
