package cn.rankin.userservice.controller;

import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.user.entity.UserTagProductRelation;
import cn.rankin.userservice.service.UserTagProductRelationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/userTagProductRelation")
public class UserTagProductRelationController {

    @Autowired
    private UserTagProductRelationService userTagProductRelationService;

    @RequestMapping(value = "/{userTagId}",method = RequestMethod.GET)
    public List<UserTagProductRelation> findByUserTagId(@PathVariable("userTagId") String userTagId) {
        List<UserTagProductRelation> userTagProductRelations = userTagProductRelationService.findByUserTagId(userTagId);
        return userTagProductRelations;
    }

    @RequestMapping(value = "/page/{userTagId}",method = RequestMethod.GET)
    public Page<UserTagProductRelation> findPageByUserTagId(@PathVariable("userTagId") String userTagId,
                                                            @RequestParam("pageNo") Integer pageNo,
                                                            @RequestParam("pageSize") Integer pageSize) {
        return userTagProductRelationService.findPageByUserTagId(userTagId, pageNo, pageSize);
    }


    @RequestMapping(value = "/page/pids",method = RequestMethod.POST)
    public Page<UserTagProductRelation> findPageByPidsUserTagId(@RequestParam("userTagId") String userTagId,
                                                            @RequestBody List<String> pids,
                                                            @RequestParam("pageNo") Integer pageNo,
                                                            @RequestParam("pageSize") Integer pageSize) {
        return userTagProductRelationService.findPageByPidsUserTagId(userTagId, pids,  pageNo, pageSize);
    }
}
