package cn.rankin.userservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.auth.dto.AuthDTO;
import cn.rankin.data.api.auth.dto.AuthQueryDTO;
import cn.rankin.data.api.auth.vo.AuthVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;


@FeignClient(name = "auth-remote", url = "${remote.auth.url}")
//@FeignClient(name = "${iaas.auth.url}")
public interface RemoteAuthFeign {

    @RequestMapping(value = "/acenter/v1/auth/list/v2", method = RequestMethod.POST)
    APIResult<Page<AuthVo>> findAuthList(AuthQueryDTO authQueryDTO);

    @RequestMapping(value = "/acenter/v1/auth", method = RequestMethod.POST)
    APIResult saveOrUpdateAuth(@RequestBody AuthDTO dto);

}
