package cn.rankin.userservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.auth.dto.AuthDTO;
import cn.rankin.data.api.auth.dto.AuthQueryDTO;
import cn.rankin.data.api.auth.vo.AuthVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
@Slf4j
@Service
public class RemoteAuthProxy {

    @Autowired
    private RemoteAuthFeign remoteAuthFeign;

    public Page<AuthVo> findAuthList(AuthQueryDTO authQueryDTO) {
        APIResult<Page<AuthVo>> apiResult = remoteAuthFeign.findAuthList(authQueryDTO);
        if(!apiResult.getSuccess()){
            log.info("remote server error ,code={},message={}", apiResult.getCode(), apiResult.getMessage());
            throw new RuntimeException("远程服务器错误");
        }
        return apiResult.getData();
    }

    public APIResult saveOrUpdateAuth(AuthDTO dto) {
        APIResult apiResult = remoteAuthFeign.saveOrUpdateAuth(dto);
        if(!apiResult.getSuccess()){
            log.info("remote server error ,code={},message={}", apiResult.getCode(), apiResult.getMessage());
            throw new RuntimeException("远程服务器错误");
        }
        return apiResult;
    }
}
