package cn.rankin.userservice.proxy;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.userservice.dto.RemoteUser;
import cn.rankin.userservice.dto.UserLogin;
import cn.rankin.userservice.dto.UserPasswd;
import cn.rankin.userservice.dto.UserRegistry;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@FeignClient(name = "user-remote", url = "${remote.user.url}")
//@FeignClient(name = "${iaas.user.url}")
public interface RemoteUserFeign {

    @RequestMapping(value = "/ucenter/v1/users", method = RequestMethod.POST)
    APIResult<RemoteUser> register(@RequestBody UserRegistry user, @RequestHeader("userIp") String userIp, @RequestHeader("appVer") String appVer);

    @RequestMapping(value = "/ucenter/v1/users/token", method = RequestMethod.POST)
    APIResult<List<RemoteUser>> login(@RequestBody UserLogin user, @RequestHeader("userIp") String userIp, @RequestHeader("appVer") String appVer);

    @RequestMapping(value = "/ucenter/v1/users/{uid}/passwd", method = RequestMethod.PUT)
    APIResult<Object> passwd(@PathVariable("uid") String userId, @RequestBody UserPasswd userPasswd, @RequestHeader("userIp") String userIp, @RequestHeader("appVer") String appVer);
}
