package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.UserTagProductRelation;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface UserTagProductRelationRepository extends BasicJpaRepository<UserTagProductRelation, String> {

    @Query(value = "select r from UserTagProductRelation r where r.tagId = ?1 and r.status = ?2 order by r.sort")
    List<UserTagProductRelation> findByTagId(String tagId, BaseStatusEnum status);

    List<UserTagProductRelation> findByTagId(String tagId);

    @Modifying
    @Query(value = "update UserTagProductRelation r set r.status = 1 where r.tagId = :tagId")
    Integer deleteByTagId(@Param("tagId") String tagId);

    @Query(value = "select * from u_user_tag_product_relation r where r.tag_id = ?1 and r.pid in (?2) and r.status = 0 order by r.sort limit ?3, ?4  ", nativeQuery = true)
    List<UserTagProductRelation> findByUserTagIdAndPids(String tagId, List<String> productIdList, Long start, Integer size);
}
