package cn.rankin.userservice.utils;

import cn.rankin.common.utils.constant.Constant;
import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.data.api.user.dto.*;
import cn.rankin.data.api.user.entity.*;
import cn.rankin.userservice.dto.UserRegistry;
import org.bouncycastle.crypto.digests.WhirlpoolDigest;
import org.springframework.beans.BeanUtils;

import java.math.BigDecimal;

public class DTOConverter {

    public static Merchant convert(MerchantDTO merchantDTO) {
        Merchant merchant = new Merchant();
        BeanUtils.copyProperties(merchantDTO, merchant);
        merchant.setBalance(BigDecimal.ZERO);
        return merchant;
    }

    public static CmsUser convert(CmsUserDTO userDTO) {
        CmsUser user = new CmsUser();
        BeanUtils.copyProperties(userDTO, user);
        return user;
    }

    public static Campus convert(CampusDTO campusDTO) {
        Campus campus = new Campus();
        BeanUtils.copyProperties(campusDTO, campus);
        campus.setName();
        return campus;
    }

    public static TerminalUser convert(TerminalUserDTO terminalUserDTO) {
        TerminalUser terminalUser = new TerminalUser();
        BeanUtils.copyProperties(terminalUserDTO, terminalUser);
        return terminalUser;
    }

    public static UserRegistry convert(TerminalUser terminalUser) {
        UserRegistry userRegistry = new UserRegistry();
        userRegistry.setEntry(terminalUser.getCode());
        userRegistry.setEntryType(Constant.EntryType.EID);
        userRegistry.setPasswd(terminalUser.getPassword());
        return userRegistry;
    }

    public static Collection convert(CollectionDTO collectionDTO) {
        Collection collection = new Collection();
        BeanUtils.copyProperties(collectionDTO, collection);
        return collection;
    }

    public static EventLog convert(EventLogDTO eventLogDTO) {
        EventLog eventLog = new EventLog();
        BeanUtils.copyProperties(eventLogDTO, eventLog);
        eventLog.setStatus(BaseStatusEnum.NORMAL);
        return eventLog;
    }

    public static WhiteUser convert(WhiteUserDTO whiteUserDTO) {
        WhiteUser whiteUser = new WhiteUser();
        BeanUtils.copyProperties(whiteUserDTO, whiteUser);
        return whiteUser;
    }

    public static UserTag convert(UserTagDTO userTagDTO) {
        UserTag userTag = new UserTag();
        BeanUtils.copyProperties(userTagDTO, userTag);
        return userTag;
    }

    public static DownloadInfo convert(DownloadInfoDTO downloadInfoDTO) {
        DownloadInfo downloadInfo = new DownloadInfo();
        BeanUtils.copyProperties(downloadInfoDTO, downloadInfo);
        return downloadInfo;
    }
}
